package solution.school;

public class CastingDemo {

  private static String greetAdvisor(Student s) {
    if (s instanceof GradStudent) {
      GradStudent gs = (GradStudent) s;
      return "Hi, " + gs.getAdvisor();
    } else {
      return "This student has no advisor!";
    }
  }

  public static void main(String[] args) {
    Student john = new Student("John Doe", "john@email.com");
    System.out.println(greetAdvisor(john));

    Student jane = new GradStudent("Jane Doe", "jane@email.com");
    System.out.println(greetAdvisor(jane));

    GradStudent matt = new GradStudent("Matt Doe", "matt@email.com");
    matt.setAdvisor("Dr. Strangelove");
    System.out.println(greetAdvisor(matt));
  }

}

